
% numerical experiments for TMz polarization
clear
n_thetas=10;
% "analytical" solution - use high number of layers for refinement
[R_Ez,thetas]=analytical_Ez(10000,n_thetas);
normEz=norm(R_Ez);
% linear elements - no restriction on number of nodes
count=1;
for n=5001:200:7001
    [R1,theta,avg_time_linear]=linearFEM_Ez(n,n_thetas);
    error1_Ez(count)=norm(R1-R_Ez)/normEz;
    %times1(count)=avg_time_linear;
    nodes1(count)=n;
    count=count+1;
end
% quadratic elements - (n-1)/2 must be an integer
count=1;
for n=5001:200:7001
    [R1,theta,avg_time_quad]=quadraticFEM_Ez(n,n_thetas);
    error2_Ez(count)=norm(R1-R_Ez)/normEz;
    %times2(count)=avg_time_quad;
    nodes2(count)=n;
    count=count+1;
end
% cubic elements - (n-1)/3 must be an integer
count=1;
for n=100:102:1001
    [R1,theta,avg_time_cubic]=cubicFEM_Ez(n,n_thetas);
    error3_Ez(count)=norm(R1-R_Ez)/normEz;
   % times3(count)=avg_time_cubic;
    nodes3(count)=n;
    count=count+1;
end
% quartic elements - (n-1)/4 must be an integer
count=1;
for n=101:100:1001
    [R1,theta,avg_time_quartic]=quarticFEM_Ez(n,n_thetas);
    error4_Ez(count)=norm(R1-R_Ez)/normEz;
   % times4(count)=avg_time_quartic;
    nodes4(count)=n;
    count=count+1;
end

figure
loglog(nodes1,error1_Ez,'-o',nodes2,error2_Ez,'-x',nodes3,error3_Ez,'-+',nodes4,error4_Ez,'-*')
title('Relative Error of Higher Order Elements using Reflection Coefficient, TM_{z} Polarization')
legend('linear','quadratic','cubic','quartic')
xlabel('# of nodes')
ylabel('relative error of reflection coefficient')
grid on

figure
loglog(nodes1,times1,'-o',nodes2,times2,'-x',nodes3,times3,'-+',nodes4,times4,'-*')
title('Average Run Times of Higher Order Elements')
legend('linear','quadratic','cubic','quartic')
xlabel('# of nodes')
ylabel('average run time of FEM solver')
grid on