
c=299792458;
u0=4*pi*1e-7;
e0=1/(c^2*u0);
f=30e9;
lambda=c/f;
L=lambda/5;

M=400
angle = linspace(0,pi/2,20)
%the material adjacent to the metamaterial slab

n0 = sqrt(u0/e0) %for vacuum
k0 = sqrt(u0*e0)*2*pi*f

%%DPS
 e1 = 5-0.1j;
 u1 = 2-0.2j;
 n1 = n0*sqrt(u1/e1)*cos(angle);
 k1 = k0*sqrt(u1.*e1-sin(angle).^2);

% %DNG
e1 = -5-0.1j;
u1 = -2-0.2j;
n1 = n0*sqrt(u1/e1)*cos(angle);
k1 = -k0*sqrt(u1.*e1-sin(angle).^2);
% % 
% ENG
%  e1 = -5-0.1j;
% u1 = 2-0.2j;
% n1 = n0*sqrt(u1/e1)*cos(angle);
% k1 = -k0*sqrt(u1.*e1-sin(angle).^2);
% 
% % %%MNG 
%  e1 = 5-0.1j;
%  u1 = -2-0.2j;
%  n1 = n0*sqrt(u1/e1)*cos(angle);
%  k1 = k0*sqrt(u1.*e1-sin(angle).^2);
% % 
 %checked all of the above so that Im(k) < 0 and Re(n) > 0
%for PEC
Zin = j*n1.*tan(k1*L);
Rslab1 = (Zin-n0)./(Zin+n0);
%for vacuum
%Zin = nDNG.*(n0+j*nDNG.*tan(kDNG*L))./(nDNG+j*n0*tan(kDNG*L))

%(nDNG.^2-nDPS.^2).*tan(kDNG*L)./((nDNG.^2+nDPS.^2).*tan(kDNG*L)-2*j*nDNG.*nDPS)
%a = linspace(0,1,100)
%nDPS = n0*sqrt(1-a.^2) 
%nDNG = n0*sqrt(1-a.^2/4)
%kDPS = k0*sqrt(1-a.^2)
%kDNG = -2*k0*sqrt(1-a.^2/4)
%Rkx = (nDNG.^2-nDPS.^2).*tan(kDNG*L)./((nDNG.^2+nDPS.^2).*tan(kDNG*L)-2*j*nDNG.*nDPS)

x = linspace(0,L,M+1); %x(1) = 0, x(m+1) = L. the length, minus 1, is the number of layers. 
y = linspace((x(2)+x(1))/2, (x(M+1)+x(M))/2,M); %this is the center of each layer.
er = linspace(e1,e1,M);
er(M+1) = 1;
ur = linspace(u1,u1,M);
ur(M+1) = 1;
for p = 1:length(angle)
   theta = angle(p);
kx = f*2*pi*sqrt(u0*e0)*sqrt(ur.*er-sin(theta)^2);

%check that Im(k) < 0 , else flip sign
% if imag(kx(1)) >0
%     kx = -kx;
% end
R(1) = -1;

% %epol
for m =1:M %to find the reflection coefficient at each boundary layer, before the boundary at the vacuum interface
    n(m+1) = (ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
    
%      if real(n(m+1))<0
%          n(m+1) = -n(m+1);
%      end
    R(m+1) = (n(m+1)+R(m).*exp(-2*j*kx(m).*x(m+1)))/(1+n(m+1)*R(m).*exp(-2*j*kx(m).*x(m+1))).*exp(2*j*kx(m+1)*x(m+1));
    
end

%hpol
% for i =1:M
%     n(i+1) = (er(i).*kx(i+1)-er(i+1).*kx(i))./(er(i).*kx(i+1)+er(i+1).*kx(i));
%     R(i+1) = exp(2*j*kx(i+1)*x(i+1)).*(n(i+1)+R(i).*exp(-2*j*kx(i).*x(i+1)))/(1+n(i+1)*R(i).*exp(-2*j*kx(i).*x(i+1)));
%     
% end
Rmplus1(p) = R(M+1);

end

%ylim([0,1])
 myPlot2 = figure(2)
 error1=(abs(Rslab1)-abs(Rmplus1))/norm(abs(Rslab1));
  error2=(abs(Rslab2)-abs(Rmplus2))/norm(abs(Rslab2));

semilogy(angle*180/pi,error1,'-',angle*180/pi,error2,'-') 
%plot(angle*180/pi,abs(Rmplus1),'o-',angle*180/pi,abs(Rmplus2),'x-')
%plot(angle*180/pi,imag(Rmplus1),'xr',angle*180/pi,imag(Rslab1),'r',angle*180/pi,real(Rmplus1),'xb',angle*180/pi,real(Rslab1),'b')
 
legend('DPS/DNG','ENG/MNG')
ylabel('Relative Error of Reflection coefficient')
xlabel('Angle \theta [degrees]')
set(myPlot2,'Position',[400,400,400,250])
xlim([0,90])
ylim([10^-10,1])
%myPlot1 = figure(1)
% plot(angle*180/pi,imag(Rmplus2),'xr',angle*180/pi,imag(Rslab2),'r',angle*180/pi,real(Rmplus2),'xb',angle*180/pi,real(Rslab2),'b')

%legend('Im','Iman','Re','Rean')
% ylabel('Reflection coefficient')
% xlabel('Angle \theta [degrees]')
% set(myPlot1,'Position',[400,400,400,250])

% xlim([0,90])
%ylim([0,0.0001])
%legend('FEM','Analytical')