M=1000
%note: M here is the number of layers! but this doesn't really matter very
%much as the solution doesn't vary much with change in M for sufficiently
%large M.
%clear
c=299792458;
u0=4*pi*1e-7;
e0=1/(c^2*u0);
f=30e9;
lambda=c/f;
L=5*lambda;
x = linspace(0,L,M+1); %x(1) = 0, x(m+1) = L. the length, minus 1, is the number of layers. 
y = linspace((x(2)+x(1))/2, (x(M+1)+x(M))/2,M) %this is the center of each layer.
er = linspace(5-j*0.1,5-j*0.1,M)
er(M+1) = 1
ur = linspace(2-j*0.2,2-j*0.2,M);
ur(M+1) = 1
angle = linspace(0,90,91)*pi/180
for p = 1:91
   theta = angle(p)
%k0 = f*2*pi*sqrt(u0*e0*ur.*er); 
%kx = k0*cos(theta) %of each layer
%kx(M+1) = f*2*pi*sqrt(u0*e0)*cos(theta)
kx = f*2*pi*sqrt(u0*e0)*sqrt(ur.*er-sin(theta)^2)
R(1) = -1;

% %epol
for m =1:M %to find the reflection coefficient at each boundary layer, before the boundary at the vacuum interface
    n(m+1) = (ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
    R(m+1) = (n(m+1)+R(m).*exp(-2*j*kx(m).*x(m+1)))/(1+n(m+1)*R(m).*exp(-2*j*kx(m).*x(m+1))).*exp(2*j*kx(m+1)*x(m+1));
    
end

%hpol
% for i =1:M
%     n(i+1) = (er(i).*kx(i+1)-er(i+1).*kx(i))./(er(i).*kx(i+1)+er(i+1).*kx(i));
%     R(i+1) = exp(2*j*kx(i+1)*x(i+1)).*(n(i+1)+R(i).*exp(-2*j*kx(i).*x(i+1)))/(1+n(i+1)*R(i).*exp(-2*j*kx(i).*x(i+1)));
%     
% end
Rmplus1(p) = R(M+1)

end
subplot(2,1,1)
plot(x,R)
plot(angle*180/pi,abs(Rmplus1))
ylim([0,1])