
c=299792458;
u0=4*pi*1e-7;
e0=1/(c^2*u0);
f=30e9;
lambda=c/f;
L=lambda*5;

M=400
angle = linspace(0,pi/2,20)
%the material adjacent to the metamaterial slab

n0 = sqrt(u0/e0) %for vacuum
k0 = sqrt(u0*e0)*2*pi*f

%%DPS
 e1 = 6-0.1j;
 u1 = 2-0.1j;
 n1 = n0*sqrt(u1/e1)*cos(angle);
 k1 = k0*sqrt(u1.*e1-sin(angle).^2);

% %DNG
e1 = -6-0.1j;
u1 = -2-0.1j;
n1 = n0*sqrt(u1/e1)*cos(angle);
k1 = -k0*sqrt(u1.*e1-sin(angle).^2);

ENG
 e1 = -6-0.1j;
u1 = 2-0.1j;
n1 = n0*sqrt(u1/e1)*cos(angle);
k1 = -k0*sqrt(u1.*e1-sin(angle).^2);

% % %%MNG 
%  e1 = 6-0.1j;
%  u1 = -2-0.2j;
%  n1 = n0*sqrt(u1/e1)*cos(angle);
%  k1 = k0*sqrt(u1.*e1-sin(angle).^2);
% 

Zin = j*n1.*tan(k1*L);
Rslabeng= (Zin-n0)./(Zin+n0);

myPlot=figure(1)
plot(angle*180/pi,abs(Rslabdps),angle*180/pi,abs(Rslabdng),'o',angle*180/pi,abs(Rslabeng),'x-',angle*180/pi,abs(Rslabmng),'h-')
%plot(angle*180/pi,abs(Rslabeng)-abs(Rslabmng))
ylabel('Reflection coefficient')
xlabel('Angle \theta [degrees]')
set(myPlot,'Position',[400,400,400,250])
ylim([0,1])
xlim([0,90])
legend('DPS','DNG','ENG','MNG')


% edng = abs(Rdng - Rfemdng)./abs(Rdng)
% edps = abs(Rdps - Rfemdps)./abs(Rdps)
% emng = abs(Rmng - Rfemmng)./abs(Rdng)
% eeng = abs(Reng - Rfemeng)./abs(Rdng)
% % myPlot=figure(1)
% % ylabel('Reflection coefficient')
% % xlabel('Angle \theta [degrees]')
% % set(myPlot,'Position',[400,400,400,250])
% % ylim([10^-10,1])
% % xlim([0,90])
% % legend('DPS/DNG','ENG/MNG')
% 
% myPlot=figure(2)
% semilogy(angle*180/pi,eps,angle*180/pi,edng,'-',angle*180/pi,eeng,'-',angle*180/pi,emng,'-')
% ylim([10^-10,1])
% ylabel('Reflection coefficient')
% xlabel('Angle \theta [degrees]')
% set(myPlot,'Position',[400,400,400,250])
% xlim([0,90])
% legend('DPS','DNG','ENG','MNG')