n = 201
M=(n-1)/2
c=299792458;
u0=4*pi*1e-7;
e0=1/(c^2*u0);
k0 = sqrt(u0/e0);
f=30e9;
lambda=c/f;
L=5*lambda;
x = linspace(0,L,M+1); %x(1) = 0, x(m+1) = L. the length, minus 1, is the number of layers. 
y = linspace((x(2)+x(1))/2, (x(M+1)+x(M))/2,M); %this is the center of each layer.

%comment out everything but the options appropriate for the material being
%studied
%ENG/DNG
er =-4+(-2-j*0.1)*(1-y/L).^2; %should be calculated in each layer, NOT at each node.
er(M+1) = 1;
% %MNG/DPS
% er =4+(2-j*0.1)*(1-y/L).^2; 
% er(M+1) = 1;

% %MNG/DNG
% ur = linspace(-2-j*0.1,-2-j*0.1,M);
% ur(M+1) = 1;
% %ENG/DPS
ur = linspace(2-j*0.1,2-j*0.1,M);
ur(M+1) = 1;

angle = linspace(0,90,21)*pi/180;
%analytical
for p = 1:length(angle)
   theta = angle(p);
kx = f*2*pi*sqrt(u0*e0)*sqrt(ur.*er-sin(theta)^2);
if imag(kx(10)) >0
    kx = -kx;
end
R(1) = -1;
%%ENG/DNG
for m =1:M-1 %to find the reflection coefficient at each boundary layer, before the boundary at the vacuum interface
    na(m+1) = (ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
    R(m+1) = (na(m+1)+R(m).*exp(2*j*kx(m).*x(m+1)))/(1+na(m+1)*R(m).*exp(2*j*kx(m).*x(m+1))).*exp(-2*j*kx(m+1)*x(m+1));
    
end
for m = M
    na(m+1) = (ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
     R(m+1) = (na(m+1)+R(m).*exp(2*j*kx(m).*x(m+1)))/(1+na(m+1)*R(m).*exp(2*j*kx(m).*x(m+1))).*exp(-2*j*kx(m+1)*x(m+1));
end   

%%DPS/MNG
% for m =1:M-1 %to find the reflection coefficient at each boundary layer, before the boundary at the vacuum interface
%     na(m+1) = (ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
%     R(m+1) = (na(m+1)+R(m).*exp(-2*j*kx(m).*x(m+1)))/(1+na(m+1)*R(m).*exp(-2*j*kx(m).*x(m+1))).*exp(2*j*kx(m+1)*x(m+1));
%     
% end
% for m = M
%     na(m+1) = (ur(m)*kx(m+1)-ur(m+1)*kx(m))./(ur(m)*kx(m+1)+ur(m+1)*kx(m));
%      R(m+1) = (na(m+1)+R(m).*exp(-2*j*kx(m).*x(m+1)))/(1+na(m+1)*R(m).*exp(-2*j*kx(m).*x(m+1))).*exp(2*j*kx(m+1)*x(m+1));
% end   

Reng(p) = R(M+1)
end

% set nodes
% get 1D quadrature rules
[pts,wghts]=gaussian_quad(10);
x=linspace(0,L,n)';
E0=1;
k0=2*pi/lambda;
% set functions for alpha and beta using eps_r and mu_r
%ENG/DNG
er=@(x) -4+(-2-j*0.1)*(1-x/L).^2;  
%%MNG/DPS
% er=@(x) 4+(2-j*0.1)*(1-x/L).^2;  

%%ENG/DPS
ur=2-j*0.1;
% MNG/DNG
% ur=-2-j*0.1;

a=1/ur;     b=@(x,theta) -(k0^2)*(-sqrt((er(x)-(sin(theta)^2)/ur))).^2; 
% set functions for N_i and dN_i/dx for i=1,2,3
N1=@(x,x1,x2,x3) (x-x2).*(x-x3)/((x1-x2)*(x1-x3));
N2=@(x,x1,x2,x3) (x-x1).*(x-x3)/((x2-x1)*(x2-x3));
N3=@(x,x1,x2,x3) (x-x1).*(x-x2)/((x3-x1)*(x3-x2));
dN1=@(x,x1,x2,x3) (2*x-x2-x3)/((x1-x2)*(x1-x3));
dN2=@(x,x1,x2,x3) (2*x-x1-x3)/((x2-x1)*(x2-x3));
dN3=@(x,x1,x2,x3) (2*x-x1-x2)/((x3-x1)*(x3-x2));

%angle=linspace(0,90,n_thetas)*pi/180';
for thetas=1:length(angle)
    tic
    theta1=angle(thetas);
    K=zeros(n,n);
    B=zeros(n,1);
    for count=1:M
        x1=x(2*count-1);    x2=x(2*count);    x3=x(2*count+1);
        % recompute quadrature nodes and weights for the interval [x1,x3]
        pts1=pts*(x3-x1)+x1;
        wghts1=wghts*(x3-x1);
        % element matrix entries are computed numerically using
        % Gaussian quadrature
        ke(1,1)=sum(wghts1.*(a*dN1(pts1,x1,x2,x3).*dN1(pts1,x1,x2,x3)+b(pts1,theta1).*N1(pts1,x1,x2,x3).*N1(pts1,x1,x2,x3)));
        ke(1,2)=sum(wghts1.*(a*dN1(pts1,x1,x2,x3).*dN2(pts1,x1,x2,x3)+b(pts1,theta1).*N1(pts1,x1,x2,x3).*N2(pts1,x1,x2,x3)));
        ke(1,3)=sum(wghts1.*(a*dN1(pts1,x1,x2,x3).*dN3(pts1,x1,x2,x3)+b(pts1,theta1).*N1(pts1,x1,x2,x3).*N3(pts1,x1,x2,x3)));
        ke(2,2)=sum(wghts1.*(a*dN2(pts1,x1,x2,x3).*dN2(pts1,x1,x2,x3)+b(pts1,theta1).*N2(pts1,x1,x2,x3).*N2(pts1,x1,x2,x3)));
        ke(2,3)=sum(wghts1.*(a*dN2(pts1,x1,x2,x3).*dN3(pts1,x1,x2,x3)+b(pts1,theta1).*N2(pts1,x1,x2,x3).*N3(pts1,x1,x2,x3)));
        ke(3,3)=sum(wghts1.*(a*dN3(pts1,x1,x2,x3).*dN3(pts1,x1,x2,x3)+b(pts1,theta1).*N3(pts1,x1,x2,x3).*N3(pts1,x1,x2,x3)));
        ke(2,1)=ke(1,2); ke(3,1)=ke(1,3); ke(3,2)=ke(2,3); 
        % fill global K matrix and b vector
        K(2*count-1:2*count+1,2*count-1:2*count+1)=K(2*count-1:2*count+1,2*count-1:2*count+1)+ke;
    end
    q=2*j*k0*E0*cos(theta1)*exp(j*k0*L*cos(theta1));
    gamma=j*k0*cos(theta1);
    % Impose boundary conditions
    K(1,:)=0;   K(:,1)=0;   K(1,1)=1;   B(1)=0;
    K(n,n)=K(n,n)+gamma;
    B(end)=q;
    % Solve linear system
    phi=K\B;
    phis(:,thetas)=phi;
    Rfemeng(thetas)=(phi(end)-E0*exp(j*k0*L*cos(theta1)))./(E0*exp(-j*k0*L*cos(theta1)));
end
theta=angle*180/pi;
%edng = abs(Rdng - Rfemdng)./abs(Rdng)
%edps = abs(Rdps - Rfemdps)./abs(Rdps)
%emng = abs(Rmng - Rfemmng)./abs(Rmng)
eeng = abs(Reng - Rfemeng)./abs(Reng)
myPlot=figure(1)
%plot(angle*180/pi,abs(Rfemdps),'-',angle*180/pi,abs(Rfemdng),'o',angle*180/pi,abs(Rfemeng)\,'x-',angle*180/pi,abs(Rfemmng),'h-')
plot(angle*180/pi,abs(Rfemeng),angle*180/pi,abs(Reng),'o')
ylabel('Reflection coefficient')
xlabel('Angle \theta [degrees]')
set(myPlot,'Position',[400,400,400,250])
%ylim([0,1])
xlim([0,90])
legend('FEM','analytical')
%legend('DPS','DNG','ENG','MNG')

% myPlot=figure(2)
% 
% semilogy(angle*180/pi,edps,angle*180/pi,edng,'o',angle*180/pi,eeng,'x-',angle*180/pi,emng,'h')
% legend('DPS','DNG','ENG','MNG')
% ylim([10^-5,1])
% ylabel('Relative error of reflection coefficient')
% xlabel('Angle \theta [degrees]')
% set(myPlot,'Position',[400,400,400,250])
% xlim([0,90])
% grid on
